# SPDX-License-Identifier: CC0-1.0

{ stdenv, fetchgit, dhallApps, prelude }:

stdenv.mkDerivation {
  name = "dhall-genode";
  src = fetchgit {
    url = "https://git.sr.ht/~ehmry/dhall-genode";
    rev = "672325a0f2247041cfdf9b3b0c9642adbfbd58a0";
    sha256 = "0iwniwkx0zcrfqv3dkjg5x5638xyxkhnqni4ydzg2b3bw4wa27id";
  };
  DHALL_PRELUDE = prelude + "/package.dhall";
  buildCommand = ''
    export XDG_CACHE_HOME=$TMPDIR
    cp -r $src $out
    chmod +w -R $out
    echo $DHALL_PRELUDE > $out/Prelude.dhall
    find $out -type f -exec \
      ${dhallApps.dhall.program} freeze --all --inplace {} \;
  '';
}
