-- SPDX-License-Identifier: CC0-1.0

let Genode = env:DHALL_GENODE

let Init = Genode.Init

let Child = Init.Child

let wrapHarness
    : Init.Type → Child.Type
    = env:DHALL_WRAP_HARNESS ? ./sotest-wrapper.dhall

in    λ(boot : Genode.Boot.Type)
    → { config =
          Init::{
          , children =
              [ { mapKey = "timer"
                , mapValue =
                    Child.flat
                      Child.Attributes::{
                      , binary = "hw_timer_drv"
                      , provides = [ "Timer" ]
                      }
                }
              , { mapKey = "harness", mapValue = wrapHarness boot.config }
              ]
          }
      , rom =
          let manifest = env:MANIFEST
          
          in    Genode.Boot.toRomPaths
                  [ manifest.base-hw-pc.bin.hw_timer_drv
                  , manifest.base-hw-pc.lib.ld
                  , manifest.os.bin.init
                  , manifest.sotest-producer.bin.sotest-harness
                  ]
              # boot.rom
      }
