-- SPDX-License-Identifier: CC0-1.0

let Genode = env:DHALL_GENODE

let Child = Genode.Init.Child

in  { config =
        Genode.Init::{
        , children =
            toMap
              { test-log =
                  Child.flat
                    Child.Attributes::{
                    , binary = "test-log"
                    , exitPropagate = True
                    , resources =
                        Genode.Init.Resources::{
                        , caps = 500
                        , ram = Genode.units.MiB 10
                        }
                    , routes = [ Genode.Init.ServiceRoute.parent "Timer" ]
                    }
              }
        }
    , rom =
        let manifest = env:MANIFEST
        
        in  Genode.Boot.toRomPaths [ manifest.genode-tests.bin.test-log ]
    }
