-- SPDX-License-Identifier: CC0-1.0

let Genode = env:DHALL_GENODE

let Init = Genode.Init

let Child = Init.Child

in  { config =
        Init::{
        , children =
            toMap
              { test-signal =
                  Child.flat
                    Child.Attributes::{
                    , binary = "test-signal"
                    , exitPropagate = True
                    , priority = 5
                    , resources =
                        Init.Resources::{
                        , caps = 500
                        , ram = Genode.units.MiB 10
                        }
                    , routes = [ Init.ServiceRoute.parent "Timer" ]
                    }
              }
        }
    , rom =
        let manifest = env:MANIFEST
        
        in  Genode.Boot.toRomPaths [ manifest.genode-tests.bin.test-signal ]
    }
